package asd.td4;

import asd.base.Liste;

/**
 * Une classe pour l'exercice 4 de la feuille 4.
 */
public class Ensemble {

    // ATTRIBUTS

    private Liste l; // la liste ordonne de Monome

    // CONSTRUCTEURS

    /**
     * Construit un ensemble vide.
     */
    public Ensemble() {
        l = new Liste();
    }

    /**
     * Construit un singleton contenant i.
     */
    public Ensemble(int i) {
        l = new Liste(new Integer(i));
    }

    /**
     * Construit un ensemble dont le plus petit lment est i
     * et les autres lments sont ceux de l'ensemble e.
     * Prcondition : pour x dans e, i < e.
     */
    private Ensemble(int i, Ensemble e) {
        l = new Liste(new Integer(i),e.l);
    }

    /**
     * Construit un ensemble  partir de la liste l.
     * Prcondition : la liste l est une liste strictement croissante
     * d'entiers.
     */
    private Ensemble(Liste l) {
        this.l = l;
    }

    // PRIMITIVES

    /**
     * Retourne le plus petit entier de l'ensemble.
     * Prcondition : l'ensemble n'est pas vide.
     */
    private int premier() {
        return ((Integer) l.premier()).intValue();
    }

    /**
     * Retourne l'ensmble priv de son plus petit lment.
     * Prcondition : l'ensemble n'est pas vide.
     */
    private Ensemble reste() {
        return new Ensemble(l.reste());
    }

    /**
     * Teste si l'ensemble est vide.
     */
    public boolean vide() {
        return l.vide();
    }

    // NON-PRIMITIVES  CRIRE  l'AIDE DES PRIMITIVES

    /**
     * Retourne le cardinal de l'ensemble.
     */
    public int cardinal() {
        return 0;
    }

    /**
     * Teste si l'ensemble contient l'entier i.
     */
    public boolean contient(int i) {
        return false;
    }

    /**
     * Retourne l'union de l'ensemble avec l'ensemble e.
     */
    public Ensemble union(Ensemble e) {
        return this;
    }

    /**
     * Retourne l'intersection de l'ensemble avec l'ensemble e.
     */
    public Ensemble inter(Ensemble e) {
        return new Ensemble();
    }

    /**
     * Retourne la diffrence symtrique de l'ensemble avec l'ensemble e.
     */
    public Ensemble difference(Ensemble e) {
        return this;
    }

    /**
     * Teste si l'ensemble est inclus dans l'ensemble e.
     */
    public boolean estInclusDans(Ensemble e) {
        return false;
    }

    /**
     * Retourne une chane de caractres reprsentant l'ensemble.
     */
    public String toString() {
        String s = "{";
        Ensemble e  = this;
        if ( ! e.vide() ) {
            s = s + e.premier();
            e = e.reste();
        }
        while ( ! e.vide() ) {
            s = s + ", " + e.premier();
            e = e.reste();
        }
        return s + "}";
    }
}
