package asd.td4;

import asd.base.Liste;
import java.lang.Math;

/**
 * Une classe pour l'exercice 5 de la feuille 4.
 */
public class Polynome {

    // CLASSE INTERNE

    /**
     * Une classe pour reprsenter des monmes. On dit qu'un monme a.X^n
     * est plus "grand" qu'un monme b.X^m si n > m.
     */
    private class Monome {

        /**
         * Construit le monme de coefficient coef et
         * d'exposant expo.
         * Prcondition : expo >= 0.
         */
        public Monome(int coef, int expo) {
        }

        /**
         * Teste si le monme est nul.
         */
        public boolean nul() {
            return false;
        }

        /**
         * Retourne le monme somme du monme et du monme m.
         * Prcondition : this.expo = m.expo.
         */
        public Monome plus(Monome m) {
            return null;
        }

        /**
         * Retourne le monme produit du monme et du monme m.
         */
        public Monome fois(Monome m) {
            return null;
        }

        /**
         * Teste si this.expo < m.expo.
         */
        public boolean inferieur(Monome m) {
            return false;
        }

        /**
         * Evalue le monme en i, autrement dit calcule la
         * valeur de c * (e^i) o c et e sont respectivement
         * le coefficient et l'exposant du monme.
         */
        public int evaluer(int i) {
            return 0;
        }

        public boolean egal(Monome m) {
            return false;
        }

        /**
         * Retourne une chane de caractres correspondant  la
         * reprsentation externe du monme vu comme le premier
         * monme d'un polynme.
         */
        public String toString1() {
            String s = "";
            if ( coef < 0 ) {
                s = " - ";
            }
            if ( Math.abs(coef) > 1 || expo == 0 ) {
                s = s + String.valueOf(Math.abs(coef));
            }
            if ( expo > 0 ) {
                s = s + "X";
            }
            if ( expo > 1 ) {
                s = s + "^" + String.valueOf(expo);
            }
            return s;
        }

        /**
         * Retourne une chane de caractres correspondant  la
         * reprsentation externe du monme vu comme un monme
         * d'un polynme quand ce monme n'est pas le premier.
         */
        public String toString() {
            if ( coef > 0 ) {
                return " + " + toString1();
            }
            return toString1();
        }
    }

    // ATTRIBUTS

    private Liste l; // la liste strictement dcroissante (sur
                           // les exposants) des monmes
    // CONSTRUCTEURS

    /**
     * Construit le polynme nul.
     */
    public Polynome() {
    }

    /**
     * Construit le polynme rduit au monme a.X^n avec
     * a = coef et n = expo.
     * Prcondition : expo >= 0.
     */
    public Polynome(int coef, int expo) {
    }

    /**
     * Construit un polynme dont le plus grand monme est m
     * et les autres monme sont ceux du polynme p.
     * Prcondition : pour tout monme c.X^k de p, k < n
     * o n est l'exposant de m.
     */
    private Polynome(Monome m, Polynome p) {
    }

    /**
     * Construit un polynme  partir de la liste l.
     * Prcondition : la liste l est une liste strictement dcroissante
     * de monmes.
     */
    private Polynome(Liste l) {
    }

    /**
     * Construit le polynme rduit au monme m.
     * Prcondition : m n'est pas nul.
     */
    private Polynome(Monome m) {
    }

    // PRIMITIVES

    /**
     * Retourne le plus grand monme du polynme.
     */
    private Monome premier() {
        return null;
    }

    /**
     * Retourne le polynme priv de son plus grand monme.
     */
    private Polynome reste() {
        return null;
    }

    /**
     * Teste si le polynme est nul.
     */
    public boolean nul() {
        return false;
    }

    // NON-PRIMITIVES  CRIRE  l'AIDE DES PRIMITIVES

    /**
     * Retourne la somme du polynme avec le polynme p.
     */
    public Polynome plus(Polynome p) {
        return this;
    }

    /**
     * Retourne la somme du polynme avec l'entier i.
     */
    public Polynome plus(int i) {
        return this;
    }

    /**
     * Retourne la diffrence entre le polynme et le polynme p.
     */
    public Polynome moins(Polynome p) {
        return this;
    }

    /**
     * Retourne la diffrence entre le polynme et l'entier i.
     */
    public Polynome moins(int i) {
        return this;
    }

    /**
     * Retourne le produit du polynme par le polynme p.
     */
    public Polynome fois(Polynome p) {
        return this;
    }

    /**
     * Retourne le produit du polynme par le monme m.
     */
    private Polynome fois(Monome m) {
        return this;
    }

    /**
     * Retourne le produit du polynme par l'entier i.
     */
    public Polynome fois(int i) {
        return this;
    }

    /**
     * Teste si le polynme est gal au polynme p.
     */
    public boolean egal(Polynome p) {
        return false;
    }

    /**
     * Retourne la valeur du polynme pour X = i.
     */
    public int evaluer(int i) {
        return 0;
    }

    /**
     * Retourne une chane de caractres reprsentant le polynme.
     * Complexit : O(t) o t est le nombre de termes de this.
     */
    public String toString() {
        String s = "";
        if ( nul() ) {
            return "0";
        }
        s = s + premier().toString1();
        Polynome r = reste();
        while ( ! r.nul() ) {
            s = s + r.premier().toString();
            r = r.reste();
        }
        return s;
    }
}
